

    File: source\asm\getdsa.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    1

    xxxx-ii-yyyy-cc-f--oooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


       1       1  0 +  0000                                   ;-------------------------------------------------------
       2       2  0 +                                         ;       Iron Spring PL/I Runtime Library Version 0.5
       3       3  0 +                                         ;          Distributed under the Gnu LGPL License
       4       4  0 +                                         ;
       5       5  0 +                                         ;       _pli_GetDSA - PL/I runtime support routines
       6       6  0 +                                         ;
       7       7  0 +                                         ;       Version 0.1 Alpha -- Mar, 2001
       8       8  0 +                                         ;       Copyright Peter Flass
       9       9  0 +                                         ;
      10      10  0 +                                         ;       _pli_GetDSA:   Get pointer to DSA
      11      11  0 +                                         ;       _pli_GetFlags: Get enabled condition flags
      12      12  0 +                                         ;       _pli_SetFlags: Set condition flags
      13      13  0 +                                         ;       _pli_GetGbl:   Get address of "Global" data area.       20040610
      14      14  0 +                                         ;
      15      15  0 +                                         ;       This stuff could all be done in PL/I, but
      16      16  0 +                                         ;       it would be tricky code and non-portable anyway.
      17      17  0 +                                         ;       It seems cleaner do do it in assembler.
      18      18  0 +                                         ;
      19      19  0 +                                         ;       Note that none of these routines has its own DSA,
      20      20  0 +                                         ;       they all operate with EBP->Caller's DSA.
      21      21  0 +                                         ;
      22      22  0 +                                         ;       Modifications:
      23      23  0 +                                         ;         2005-11-10 - add "SetFlags"
      24      24  0 +                                         ;         2004-08-02 - Fix 'GETFLAGS' so that (when called from
      25      25  0 +                                         ;                      a library procedure) it will return the
      26      26  0 +                                         ;                      flags in effect when that proc was called.
      27      27  0 +                                         ;         2004-06-10 - add "GetGbl"
      28      28  0 +                                         ;-------------------------------------------------------
      29      29  0 +            @Cpu=00000D9F                            .486P
      30      30  0 +                                                     .model flat,syscall
      31      31  0 +
      32      32  0 +                                                     .code
      33      33  0 +                                                     public _pli_GetDSA
      34      34  0 +                                                     public _pli_GetFlags
      35      35  0 +                                                     public _pli_SetFlags                            ; 20051110
      36      36  0 +                                                     public _pli_GetGbl                              ; 20040610
      37      37  0 +
      38      38  0 +            =00000000                        _pli_code equ $
      39      39  0 +                                                     include framedef.inc
      40  1    1  0 +                                             ;
      41  1    2  0 +                                             ;----------------------------------------------------+
      42  1    3  0 +                                             ;       PL/I Stack Frame Definition                  |
      43  1    4  0 +                                             ;----------------------------------------------------+
      44  1    5  0 +            =00000000                        frm_ebp equ      0      ; Previous caller's EBP 20040802
      45  1    6  0 +            =FFFFFFFC                        frm_edi equ     -4      ; Caller's EDI
      46  1    7  0 +            =FFFFFFF8                        frm_esi equ     -8      ; Caller's ESI
      47  1    8  0 +            =FFFFFFF4                        frm_ebx equ     -12     ; Caller's EBX
      48  1    9  0 +            =FFFFFFF0                        frm_epa equ     -16     ; Called Entry point address
      49  1   10  0 +            =FFFFFFEC                        frm_stt equ     -20     ; A(Statement number table)
      50  1   11  0 +            =FFFFFFE8                        frm_chc equ     -24     ; ONCB chain
      51  1   12  0 +            =FFFFFFE6                        frm_msk equ     -26     ; Condition mask
      52  1   13  0 +            =FFFFFFE4                        frm_epi equ     -28     ; Entry point id
      53  1   14  0 +            =FFFFFFE0                        frm_bos equ     -32     ; Current permanent BOS
      54  1   15  0 +            =00000020                        frm_len equ      32     ; Size of frame
      55  1   16  0 +


    File: source\asm\getdsa.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    2

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


      56      40  0 +                                             ;
      57      41  0 +                                             ;-----------------------------------------------------
      58      42  0 +                                             ;       _pli_GetDSA:  Return caller's DSA address [EBP]
      59      43  0 +                                             ;-----------------------------------------------------
      60      44  0 +  00000000  5F 70 6C 69 5F 47 65                     db   '_pli_GetDSA'      ; Entry point name
                                 74 44 53 41
      61      45  0 +  0000000B  0B                                       db   11                 ; Length of name
      62      46  0 +  0000000C                                   _pli_GetDSA:
      63      47  0 +  0000000C  8B C5                                    mov  eax,ebp            ; Return caller's EBP
      64      48  0 +  0000000E  C3                                       ret
      65      49  0 +
      66      50  0 +                                             ;-----------------------------------------------------
      67      51  0 +                                             ;       _pli_GetFlags:  Return caller's enabled cond flags
      68      52  0 +                                             ;-----------------------------------------------------
      69      53  0 +  0000000F  5F 70 6C 69 5F 47 65                     db   '_pli_GetFlags'    ; Entry point name
                                 74 46 6C 61 67 73
      70      54  0 +  0000001C  0D                                       db   13                 ; Length of name
      71      55  0 +  0000001D                                   _pli_GetFlags:
      72      56  0 +  0000001D  8B 45 [00]                               mov   eax,dword ptr frm_ebp[ebp]; Caller of Caller's DSA  20040802
      73      57  0 +  00000020  0F B7 40 [E6]                            movzx eax,word ptr  frm_msk[eax]; Caller of Caller's flags20040802
      74      58  0 +  00000024  86 E0                                    xchg  ah,al                     ; Correct byte order      20040802
      75      59  0 +  00000026  C3                                       ret
      76      60  0 +
      77      61  0 +                                             ;-----------------------------------------------------
      78      62  0 +                                             ;       _pli_SetFlags:  Set condition flags in DSA
      79      63  0 +                                             ;-----------------------------------------------------
      80      64  0 +  00000027  5F 70 6C 69 5F 53 65                     db   '_pli_SetFlags'    ; Entry point name
                                 74 46 6C 61 67 73
      81      65  0 +  00000034  0D                                       db   13                 ; Length of name
      82      66  0 +  00000035                                   _pli_SetFlags:
      83      67  0 +                                             ;       Non-standard stack frame, no EBP saved                    20060901
      84      68  0 +  00000035  0F B7 44/24 [04]                         movzx eax,word ptr 4[esp]       ; Get new flags           20060901
      85      69  0 +                                             ;       xchg  ah,al                     ; Correct byte order      20051110
      86      70  0 +  0000003A  66:89 45 [E6]                            mov   word ptr frm_msk[ebp],ax  ; Set flags               20051110
      87      71  0 +  0000003E  C3                                       ret
      88      72  0 +
      89      73  0 +                                             ;-----------------------------------------------------
      90      74  0 +                                             ;       _pli_GetGbl:  Return address of "Global" data
      91      75  0 +                                             ;-----------------------------------------------------
      92      76  0 +  0000003F  5F 70 6C 69 5F 47 65                     db   '_pli_GetGbl'      ; Entry point name
                                 74 47 62 6C
      93      77  0 +  0000004A  0B                                       db   11                 ; Length of name
      94      78  0 +  0000004B                                   _pli_GetGbl:
      95      79  0 +  0000004B  8B C5                                    mov  eax,ebp            ; Caller's EBP
      96      80  0 +  0000004D  8B 40 [FC]                               mov  eax,frm_edi[eax]   ; addr(PGT)
      97      81  0 +  00000050  8B 80 [000001FC]                         mov  eax,dword ptr (127*4)[eax] ; addr(_pli_gbl_data)
      98      82  0 +  00000056  C3                                       ret
      99      83  0 +
     100      84  0 +                                                     end
