

    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    1

    xxxx-ii-yyyy-cc-f--oooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


       1       1  0 +  0000                                   ;-------------------------------------------------------
       2       2  0 +                                         ;       Iron Spring PL/I Runtime Library Version 0.5
       3       3  0 +                                         ;          Distributed under the Gnu LGPL License
       4       4  0 +                                         ;
       5       5  0 +                                         ;       _pli_Init - PL/I runtime support routines
       6       6  0 +                                         ;       Version 0.1 Alpha -- Sep, 1998
       7       7  0 +                                         ;       Copyright Peter Flass
       8       8  0 +                                         ;       This module contains most of the OS dependencies
       9       9  0 +                                         ;       Compiler-generated code should be OS independent.
      10      10  0 +                                         ;
      11      11  0 +                                         ;       _pli_Init is the second stage of PL/I initialization.
      12      12  0 +                                         ;       It is called by _pli_Start, which is statically linked
      13      13  0 +                                         ;       with the user's .EXE.  It is passed the address of
      14      14  0 +                                         ;       the Global Data Structure in EAX, which it stores in
      15      15  0 +                                         ;       entry 127 in the PGT so that the Global Data can be
      16      16  0 +                                         ;       referenced both from the .EXE and the PL/I DLL if
      17      17  0 +                                         ;       the DLL is used instead of static linkage.
      18      18  0 +                                         ;
      19      19  0 +                                         ;       To Do:
      20      20  0 +                                         ;         . Add addr(TDA_address) to PGT.
      21      21  0 +                                         ;           [TDA_address is stored in thread local storage].
      22      22  0 +                                         ;         . See note on parm analyzer.
      23      23  0 +                                         ;           and definition of TIB.
      24      24  0 +                                         ;
      25      25  0 +                                         ;       Modifications:
      26      26  0 +                                         ;         2008-06-04 - Fix stack frames for 'fromalien'         0.6a
      27      27  0 +                                         ;         2008-05-21 - Fix startup logic for DLLs, add 'gbl.inc'
      28      28  0 +                                         ;         2007-11-08 - @00003 - fix PLITABS linkage.
      29      29  0 +                                         ;         2007-06-09 - Fix for problem with DosGetInfoBlocks
      30      30  0 +                                         ;         2007-03-20 - New version of 'GCL'.
      31      31  0 +                                         ;         2006-10-17 - Fix return of pliretc()
      32      32  0 +                                         ;         2006-09-27 - Reload addr(PGT) at 'exit' in case
      33      33  0 +                                         ;                       exit is jumped to out of SIG.
      34      34  0 +                                         ;         2006-08-08 - Fix invalid branch in 'probe'
      35      35  0 +                                         ;         2006-02-01 - Fix 'fpmask' for x87 setup
      36      36  0 +                                         ;         2005-05-09 - zero entry point id in DSA
      37      37  0 +                                         ;         2005-01-05 - add _pli_OTH (OTHERWISE) handler
      38      38  0 +                                         ;         2004-12-22 - Add addr(ATTN_ONCB) after ExceptionRegistrationRecord
      39      39  0 +                                         ;         2004-06-09 - Add initialization for major task TID
      40      40  0 +                                         ;         2004-05-26 - DosSetSignalExceptionFocus
      41      41  0 +                                         ;         2004-05-24 - Set initial FPU control word
      42      42  0 +                                         ;         2004-05-11 - Fix Error trapping problem
      43      43  0 +                                         ;         2003-12-14 - Rename _pli_Init, set up so that the
      44      44  0 +                                         ;                       library can run as a DLL.
      45      45  0 +                                         ;         2003-07-03 - Add heap storage allocation
      46      46  0 +                                         ;         2002-07-18 - Create _pli_End EXTERNAL label variable
      47      47  0 +                                         ;         2002-06-25 - Save A(PGT) in my stack frame to make _pli_Start
      48      48  0 +                                         ;                       look like a PL/I program for stack trace.
      49      49  0 +                                         ;         2002-06-04 - Error in SFI
      50      50  0 +                                         ;         2002-04-26 - Add beginnings of trap handler
      51      51  0 +                                         ;         2001-03-02 - Add Parm scanner
      52      52  0 +                                         ;
      53      53  0 +                                         ;-------------------------------------------------------
      54      54  0 +            @Cpu=00000D8F                            .386P
      55      55  0 +                                                     .model flat,syscall


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    2

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


      56      56  0 +
      57      57  0 +                                                     .code
      58      58  0 +            =00000000                        _pli_code equ $
      59      59  0 +                                                     public _pli_Init        ;                               20031214
      60      60  0 +                                                     public _pli_PGT
      61      61  0 +                                                     public _pli_Def_Cond
      62      62  0 +
      63      63  0 +                                                     extern DosAllocMem:near
      64      64  0 +                                                     extern DosExit:near
      65      65  0 +                                                     extern DosFreeMem:near
      66      66  0 +                                                     extern DosGetInfoBlocks:near
      67      67  0 +                                                     extern DosSetExceptionHandler:near
      68      68  0 +                                                     extern DosSetSignalExceptionFocus:near
      69      69  0 +                                                     extern DosSubSetMem:near
      70      70  0 +                                                     extern DosSubUnsetMem:near
      71      71  0 +                                                     extern DosUnsetExceptionHandler:near
      72      72  0 +
      73      73  0 +                                             ;       extern _pli_Main:near   ; Moved to plistart             20080521
      74      74  0 +                                                     extern _pli_GCL:near
      75      75  0 +                                                     extern _pli_Trap:near
      76      76  0 +
      77      77  0 +                                                     include gbl.inc
      78  1    1  0 +                                             ;
      79  1    2  0 +                                             ;----------------------------------------------------+
      80  1    3  0 +                                             ;       PL/I Global Data (GBL)                       |
      81  1    4  0 +                                             ;----------------------------------------------------+
      82  1    5  0 +            =00000000                        gbl_data_size   equ      0      ; Length of this area
      83  1    6  0 +            =00000004                        gbl_return_code equ      4      ; Return code
      84  1    7  0 +            =00000008                        gbl_main_ep     equ      8      ; Entry point of main
      85  1    8  0 +            =00000010                        gbl_get_ep      equ     16      ; GET entry point
      86  1    9  0 +            =00000018                        gbl_put_ep      equ     24      ; PUT entry point
      87  1   10  0 +                                             ;       (reserved, 8 bytes)
      88  1   11  0 +            =00000028                        gbl_user1       equ     40      ; User field 1
      89  1   12  0 +            =0000002C                        gbl_user2       equ     44      ; User field 2
      90  1   13  0 +            =00000030                        gbl_tda_anchor  equ     48      ; A(major_task_tda)
      91  1   14  0 +            =00000034                        gbl_alloc_cnt   equ     52      ; Allocation count(?)
      92  1   15  0 +            =00000038                        gbl_plitabs_addr equ    56      ; A(PLITABS)
      93  1   16  0 +                                             ;       (reserved, 36 bytes)
      94  1   17  0 +
      95  1   18  0 +
      96      78  0 +                                                     include tda.inc
      97  1    1  0 +                                             ;
      98  1    2  0 +                                             ;----------------------------------------------------+
      99  1    3  0 +                                             ;       PL/I Task Data Area (TDA) definition         |
     100  1    4  0 +                                             ;----------------------------------------------------+
     101  1    5  0 +                                             ;       (a few equates in areas not completely defined here)
     102  1    6  0 +            =0000000C                        TIB_pTib2       equ     0Ch     ; -> TIB2 in TIB
     103  1    7  0 +            =00000000                        TIB2_ulTid      equ     00h     ; Thread ID in TIB2
     104  1    8  0 +            =00000004                        TIB2_ulPri      equ     04h     ; Thread priority in TIB2
     105  1    9  0 +                                             ;
     106  1   10  0 +            =00000000                        TDA_next        equ     0       ; Addr(next_TDA)
     107  1   11  0 +            =00000004                        TDA_prev        equ     4       ; Addr(prev_TDA)
     108  1   12  0 +            =00000008                        TDA_nextchild   equ     8       ; Addr(next_child_TDA)
     109  1   13  0 +            =0000000C                        TDA_prevchild   equ     12      ; Addr(prev_child_TDA)
     110  1   14  0 +            =00000010                        TDA_parent      equ     16      ; Addr(parent_TDA)


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    3

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     111  1   15  0 +            =00000014                        TDA_TID         equ     20      ; Thread ID
     112  1   16  0 +            =00000018                        TDA_priority    equ     24      ; Priority
     113  1   17  0 +            =0000001C                        TDA_alloc_cnt   equ     28      ; Alloc Cnt for CTL stg
     114  1   18  0 +            =00000020                        TDA_event       equ     32      ; Addr(event_variable)
     115  1   19  0 +            =00000024                        TDA_stack       equ     36      ; Addr(stack)
     116  1   20  0 +            =00000028                        TDA_heap        equ     40      ; Addr(heap)
     117  1   21  0 +            =0000002C                        TDA_flags       equ     44      ; Flag byte
     118  1   22  0 +                                             ;               80h = Major Task TDA
     119  1   23  0 +            =0000002D                        TDA_fil1        equ     45      ; (alignment)
     120  1   24  0 +            =00000030                        TDA_ctl         equ     48      ; CTL storage chain
     121  1   25  0 +            =00000034                        TDA_fil2        equ     52      ; (unused)
     122  1   26  0 +
     123      79  0 +                                                     include framedef.inc
     124  1    1  0 +                                             ;
     125  1    2  0 +                                             ;----------------------------------------------------+
     126  1    3  0 +                                             ;       PL/I Stack Frame Definition                  |
     127  1    4  0 +                                             ;----------------------------------------------------+
     128  1    5  0 +            =00000000                        frm_ebp equ      0      ; Previous caller's EBP 20040802
     129  1    6  0 +            =FFFFFFFC                        frm_edi equ     -4      ; Caller's EDI
     130  1    7  0 +            =FFFFFFF8                        frm_esi equ     -8      ; Caller's ESI
     131  1    8  0 +            =FFFFFFF4                        frm_ebx equ     -12     ; Caller's EBX
     132  1    9  0 +            =FFFFFFF0                        frm_epa equ     -16     ; Called Entry point address
     133  1   10  0 +            =FFFFFFEC                        frm_stt equ     -20     ; A(Statement number table)
     134  1   11  0 +            =FFFFFFE8                        frm_chc equ     -24     ; ONCB chain
     135  1   12  0 +            =FFFFFFE6                        frm_msk equ     -26     ; Condition mask
     136  1   13  0 +            =FFFFFFE4                        frm_epi equ     -28     ; Entry point id
     137  1   14  0 +            =FFFFFFE0                        frm_bos equ     -32     ; Current permanent BOS
     138  1   15  0 +            =00000020                        frm_len equ      32     ; Size of frame
     139  1   16  0 +
     140      80  0 +                                             ;------------------------------------------------+
     141      81  0 +                                             ;  Unique Stack Data for _pli_Init               |
     142      82  0 +                                             ;------------------------------------------------+
     143      83  0 +            =FFFFFFE0                        frm_loc equ     frm_bos         ; Start of locals for _pli_Init
     144      84  0 +            =FFFFFFDC                        loc_edi equ     frm_loc-4       ; Caller's EDI 20020625
     145      85  0 +            =FFFFFFD8                        ERRHnd  equ     frm_loc-8       ; -> Error handler
     146      86  0 +            =FFFFFFD4                        ERRPerr equ     frm_loc-12      ; -> Previous Exception Rec
     147      87  0 +            =FFFFFFD4                        ERegRec equ     frm_loc-12      ; Exception Registration Record
     148      88  0 +            =FFFFFFD0                        EAttnCB equ     frm_loc-16      ; addr(ATTENTION_ONCB)          20041222
     149      89  0 +            =FFFFFFCC                        tib_addr equ    frm_loc-20      ; Temporary                     20070609
     150      90  0 +            =FFFFFFC8                        pib_addr equ    frm_loc-24      ;                               20070609
     151      91  0 +            =FFFFFFC4                        loc_end equ     frm_loc-28      ; end of local stack            20070609
     152      92  0 +            =0000001C                        loc_len equ     frm_loc-loc_end ; Length of local stack
     153      93  0 +                                             ;
     154      94  0 +                                             ;-----------------------------------------------------
     155      95  0 +                                             ;       _pli_Init:  Initialize PL/I MAIN procedure
     156      96  0 +                                             ;-----------------------------------------------------
     157      97  0 +  00000000  5F 70 6C 69 5F 49 6E                     db   '_pli_Init'; Entry point name
                                 69 74
     158      98  0 +  00000009  09                                       db   9          ; Length of name
     159      99  0 +  0000000A                                   _pli_Init:
     160     100  0 +  0000000A  A3 [00000234]:R                          mov  dword ptr _pli_PGT+GBL*4,eax; Save a(_pli_gbl_data)20031214
     161     101  0 +  0000000F  55                                       push ebp                ; Save caller's EBP
     162     102  0 +  00000010  8B EC                                    mov  ebp,esp            ; Save registers
     163     103  0 +  00000012  83 EC 3C                                 sub  esp,frm_len+loc_len; Reserve stack frame
     164     104  0 +  00000015  89 65 [E0]                               mov  frm_bos[ebp],esp   ; Save BOS address


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    4

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     165     105  0 +  00000018  89 7D [DC]                               mov  loc_edi[ebp],edi   ; Save caller's registers       20020625
     166     106  0 +  0000001B  89 75 [F8]                               mov  frm_esi[ebp],esi   ;   (edi,esi,ebx)
     167     107  0 +  0000001E  89 5D [F4]                               mov  frm_ebx[ebp],ebx
     168     108  0 +  00000021  C7 45 [F0]                               mov  dword ptr frm_epa[ebp],offset _pli_Init
                                 0000000A:R
     169     109  0 +  00000028  C7 45 [EC] 00000000                      mov  dword ptr frm_stt[ebp],0           ; Statement number table
     170     110  0 +  0000002F  C7 45 [E8] 00000000                      mov  dword ptr frm_chc[ebp],0           ; Condition handler chain
     171     111  0 +  00000036  66:A1 [000002CA]:R                       mov  ax,word ptr _pli_Def_Cond          ; Enabled conditions
     172     112  0 +  0000003C  66:89 45 [E6]                            mov  frm_msk[ebp],ax    ; Condition mask
     173     113  0 +  00000040  BF 00000038:R                            mov  edi,offset _pli_PGT; load a(PGT)
     174     114  0 +  00000045  89 7D [FC]                               mov  frm_edi[ebp],edi   ; Indicate PL/I stack frame 20020625
     175     115  0 +  00000048  8B F5                                    mov  esi,ebp            ; Static backchain
     176     116  0 +  0000004A  DB E3                                    fninit                  ; Initialize FPU (may be redundant)
     177     117  0 +  0000004C  D9 2D [000002C8]:R                       fldcw fpmask            ; Set FPU control word      20040524
     178     118  0 +
     179     119  0 +  00000052  FC                                       cld                     ; Clear direction flag
     180     120  0 +                                             ;
     181     121  0 +                                             ;-----------------------------------------------------
     182     122  0 +                                             ;       Initialize Major Task TDA [2004-06-09]
     183     123  0 +                                             ;       NOTE: There is a bug in some versions of Warp
     184     124  0 +                                             ;             that will not allow NULL as an argument
     185     125  0 +                                             ;             to DosGetInfoBlocks.  APAR JR10561 is
     186     126  0 +                                             ;             the fix for this in Warp 4.
     187     127  0 +                                             ;-----------------------------------------------------
     188     128  0 +  00000053  8D 45 [C8]                               lea  eax,pib_addr[ebp]                  ; *PTIB         20070609
     189     129  0 +  00000056  50                                       push eax                                ;               20070609
     190     130  0 +  00000057  8D 45 [CC]                               lea  eax,tib_addr[ebp]                  ; *PTIB         20070609
     191     131  0 +  0000005A  50                                       push eax
     192     132  0 +  0000005B  E8 00000000:E                            call DosGetInfoBlocks
     193     133  0 +  00000060  83 C4 08                                 add  esp,8                              ; Pop arguments
     194     134  0 +  00000063  8B 3D [00000234]:R                       mov  edi,dword ptr _pli_PGT+GBL*4       ; addr(_pli_gbl_data)
     195     135  0 +  00000069  8B 7F [30]                               mov  edi,dword ptr gbl_tda_anchor[edi]  ; addr(initial TDA)
     196     136  0 +  0000006C  8B 45 [CC]                               mov  eax,dword ptr tib_addr[ebp]        ; addr(TIB)     20070609
     197     137  0 +  0000006F  8B 40 [0C]                               mov  eax,dword ptr TIB_pTib2[eax]       ; addr(TIB2)
     198     138  0 +  00000072  8B 18                                    mov  ebx,dword ptr TIB2_ulTid[eax]      ; Thread ID
     199     139  0 +  00000074  89 5F [14]                               mov  dword ptr TDA_TID[edi],ebx
     200     140  0 +  00000077  8B 58 [04]                               mov  ebx,dword ptr TIB2_ulPri[eax]      ; Thread priority
     201     141  0 +  0000007A  89 5F [18]                               mov  dword ptr TDA_priority[edi],ebx
     202     142  0 +  0000007D  C6 47 [2C] 80                            mov  byte ptr TDA_flags[edi],80h        ; 'Major Task'
     203     143  0 +                                             ;       Other fields: Heap addr, stack addr?
     204     144  0 +                                             ;
     205     145  0 +
     206     146  0 +                                             ;--->   Set edi to point to the PGT throughout the rest of initialization <---
     207     147  0 +  00000081  BF 00000038:R                            mov  edi,offset _pli_PGT; load a(PGT)   ; Load PGT address
     208     148  0 +                                             ;--->   From this point on, *do not* use edi without saving and restoring <---
     209     149  0 +
     210     150  0 +                                             ;
     211     151  0 +                                             ;-----------------------------------------------------
     212     152  0 +                                             ;       Initialize Exit address [2002-07-18]
     213     153  0 +                                             ;-----------------------------------------------------
     214     154  0 +  00000086  A1 [0000023F]:R                          mov  eax,AExit                          ; mov  dword ptr _End,eax
     215     155  0 +  0000008B  A3 [00000000]:R                          mov  dword ptr _End,eax
     216     156  0 +  00000090  89 2D [00000004]:R                       mov  dword ptr _End+4,ebp
     217     157  0 +                                             ;
     218     158  0 +                                             ;-----------------------------------------------------


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    5

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     219     159  0 +                                             ;       Initialize Trap Handler [2002-04-26]
     220     160  0 +                                             ;-----------------------------------------------------
     221     161  0 +  00000096  8D 45 [D4]                               lea  eax,ERegRec[ebp]   ; A(Exception Registration REC)
     222     162  0 +  00000099  C7 00 00000000                           mov  dword ptr 0[eax],0 ; Initialize Chain
     223     163  0 +  0000009F  C7 40 [04]                               mov  dword ptr 4[eax],offset _pli_Trap  ; Exception handler address     20040511
                                 00000000:E
     224     164  0 +  000000A6  C7 40 [08] 00000000                      mov  dword ptr 8[eax],0         ; Init ATTENTION ONCB chain             20041222
     225     165  0 +  000000AD  50                                       push eax
     226     166  0 +  000000AE  E8 00000000:E                            call DosSetExceptionHandler
     227     167  0 +  000000B3  83 C4 04                                 add  esp,4
     228     168  0 +                                             ;
     229     169  0 +                                             ;-----------------------------------------------------
     230     170  0 +                                             ;       Call Parm Analyzer [Rev Mar 20, 2007]
     231     171  0 +                                             ;       [This will run with _pli_Main's stack and no
     232     172  0 +                                             ;       heap storage.]
     233     173  0 +                                             ;-----------------------------------------------------
     234     174  0 +  000000B6  68 00000238:R                            push dword ptr offset _pli_runtime_parms  ; a(runtime parms)            20070320
     235     175  0 +  000000BB  B0 01                                    mov  al,1
     236     176  0 +  000000BD  E8 00000000:E                            call _pli_GCL                           ; analyze command line
     237     177  0 +  000000C2  83 C4 04                                 add  esp,4                              ; pop rtp addr                  20070320
     238     178  0 +  000000C5  A1 [00000248]:R                          mov  eax,rtp_lCmdl                      ; Load parm length              20070320
     239     179  0 +  000000CA  A3 [000002C4]:R                          mov  dword ptr desc+4,eax               ; set descriptor length 20070320
     240     180  0 +  000000CF  83 C0 02                                 add  eax,2                              ; Add length(var_str_pfx)       20070320
     241     181  0 +  000000D2  FF 97 [00000010]                         call near ptr GSS*4[edi]                ; Get stack space               20070320
     242     182  0 +  000000D8  8B F8                                    mov  edi,eax                            ; Load the address              20070320
     243     183  0 +  000000DA  89 7D [E0]                               mov  frm_bos[ebp],edi                   ; Save BOS address              20070320
     244     184  0 +  000000DD  89 3D [000002B8]:R                       mov  dword ptr adata,edi                ; Save parm addr                20070320
     245     185  0 +  000000E3  8B 0D [000002C4]:R                       mov  ecx,dword ptr desc+4               ; Length(parm)                  20070320
     246     186  0 +  000000E9  66:89 0F                                 mov  word ptr 0[edi],cx                 ; Save string length            20070320
     247     187  0 +  000000EC  85 C9                                    test ecx,ecx                            ; Length=zero?                  20070320
     248     188  0 +  000000EE  74 0F 90 90 90 90                        je   noparm                             ; Yes                           20070320
     249     189  0 +  000000F4  83 C7 02                                 add  edi,2                              ; -> output string              20070320
     250     190  0 +  000000F7  8B 35 [00000244]:R                       mov  esi,rtp_pCmdl                      ; -> input string               20070320
     251     191  0 +  000000FD  F3:A4                                rep movsb                                   ; Move parm to stack            20070320
     252     192  0 +  000000FF                                   noparm:
     253     193  0 +  000000FF  BF 00000038:R                            mov  edi,offset _pli_PGT; load a(PGT)   ; Restore PGT address           20070320
     254     194  0 +
     255     195  0 +                                             ;
     256     196  0 +                                             ;-----------------------------------------------------
     257     197  0 +                                             ;       Allocate heap storage [Jul 3, 2003]
     258     198  0 +                                             ;       The parm analyzer may have changed
     259     199  0 +                                             ;       the size of the heap.
     260     200  0 +                                             ;-----------------------------------------------------
     261     201  0 +  00000104  6A 03                                    push 03H                                ; Flags
     262     202  0 +                                             ;                                                       PAG_READ  01h
     263     203  0 +                                             ;                                                       PAG_WRITE 02h
     264     204  0 +  00000106  A1 [00000238]:R                          mov  eax,def_heap_size                  ; cb (=heap size)
     265     205  0 +  0000010B  50                                       push eax
     266     206  0 +  0000010C  8D 05 00000000:R                         lea  eax,_Heap                          ; ppb
     267     207  0 +  00000112  50                                       push eax
     268     208  0 +  00000113  B0 03                                    mov  al,3
     269     209  0 +  00000115  E8 00000000:E                            call DosAllocMem                        ; Allocate the heap
     270     210  0 +  0000011A  83 C4 0C                                 add  esp,12                             ; pop parms
     271     211  0 +                                             ; NOTE: Need to check return code
     272     212  0 +                                             ;       What to do if error occurs?


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    6

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     273     213  0 +
     274     214  0 +  0000011D  A1 [00000238]:R                          mov  eax,def_heap_size                  ; cb (=heap size)
     275     215  0 +  00000122  50                                       push eax
     276     216  0 +  00000123  6A 05                                    push 05h                                ; Flags
     277     217  0 +                                             ;                                                       DOSSUB_INIT       01h
     278     218  0 +                                             ;                                                       DOSSUB_SPARSE_OBJ 04h
     279     219  0 +  00000125  A1 [00000000]:R                          mov  eax,dword ptr _Heap                ; Heap address
     280     220  0 +  0000012A  50                                       push eax
     281     221  0 +  0000012B  B0 03                                    mov  al,3
     282     222  0 +  0000012D  E8 00000000:E                            call DosSubSetMem                       ; Initialize the heap
     283     223  0 +  00000132  83 C4 0C                                 add  esp,12                             ; pop parms
     284     224  0 +                                             ; NOTE: Need to check return code
     285     225  0 +                                             ;       What to do if error occurs?
     286     226  0 +                                             ;
     287     227  0 +                                             ;-----------------------------------------------------
     288     228  0 +                                             ;       Initialize I/O Router [Jul 31, 2003]
     289     229  0 +                                             ;-----------------------------------------------------
     290     230  0 +  00000135  68 00320000                              push 00320000h                          ; (0,50) = Initialize
     291     231  0 +  0000013A  54                                       push esp                                ; A(code)
     292     232  0 +  0000013B  B0 01                                    mov  al,1
     293     233  0 +  0000013D  E8 00000000:E                            call _pli_IOR
     294     234  0 +  00000142  83 C4 08                                 add  esp,8                              ; pop parms 20031211
     295     235  0 +
     296     236  0 +
     297     237  0 +                                             ;       [NOTE: At this point we want to allocate and
     298     238  0 +                                             ;              switch to the thread 1 stack]
     299     239  0 +                                             ;
     300     240  0 +
     301     241  0 +                                             ;-----------------------------------------------------
     302     242  0 +                                             ;       Set Signal Exception Focus (May 26, 2004)
     303     243  0 +                                             ;-----------------------------------------------------
     304     244  0 +                                             ;
     305     245  0 +  00000145  83 EC 04                                 sub   esp,4             ; Space for returned value
     306     246  0 +  00000148  54                                       push  esp               ; pulTimes
     307     247  0 +  00000149  6A 01                                    push  1                 ; flag: 1=SIG_SETFOCUS
     308     248  0 +  0000014B  E8 00000000:E                            call  DosSetSignalExceptionFocus
     309     249  0 +  00000150  83 C4 0C                                 add   esp,12
     310     250  0 +
     311     251  0 +                                             ;-----------------------------------------------------
     312     252  0 +                                             ;       MAIN procedure should not return a value,
     313     253  0 +                                             ;       but allow for one just in case
     314     254  0 +                                             ;-----------------------------------------------------
     315     255  0 +  00000153  83 EC 0C                                 sub   esp,12            ; Reserve space for returned value
     316     256  0 +  00000156  54                                       push  esp               ; push A(returned_value)
     317     257  0 +  00000157  68 000002B8:R                            push  dword ptr offset _pli_Main_Parm_locdesc
     318     258  0 +  0000015C  B0 01                                    mov   al,1              ; Number of parameters
     319     259  0 +                                             ;                                 EDI->PGT (set above)
     320     260  0 +                                             ;                                 Should we set ESI (static backchain)?
     321     261  0 +                                             ;       call  _pli_Main         ; Call PL/I main procedure
     322     262  0 +  0000015E  8B 35 [00000234]:R                       mov   esi,dword ptr _pli_PGT+GBL*4 ; Load a(_pli_gbl_data)    20080521
     323     263  0 +  00000164  FF 56 [08]                               call  dword ptr gbl_main_ep[esi] ; Call PL/I MAIN procedure   20080521
     324     264  0 +  00000167  83 C4 14                                 add   esp,20            ; Pop parameters off stack
     325     265  0 +
     326     266  0 +                                             ;*****************************************************
     327     267  0 +                                             ;       MAIN procedure or normal return from ERROR


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    7

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     328     268  0 +                                             ;       returns here
     329     269  0 +                                             ;*****************************************************
     330     270  0 +
     331     271  0 +  0000016A                                   exit:
     332     272  0 +
     333     273  0 +                                             ;-----------------------------------------------------
     334     274  0 +                                             ;       Close any open files [Feb 4, 2004]
     335     275  0 +                                             ;-----------------------------------------------------
     336     276  0 +  0000016A  BF 00000038:R                            mov  edi,offset _pli_PGT                ; reload a(PGT)         20060927
     337     277  0 +  0000016F  68 00330000                              push 00330000h                          ; (0,51) = Terminate
     338     278  0 +  00000174  54                                       push esp                                ; A(Dummy_IORB)
     339     279  0 +  00000175  B0 01                                    mov  al,1
     340     280  0 +  00000177  E8 00000000:E                            call _pli_IOR
     341     281  0 +  0000017C  83 C4 08                                 add  esp,8                              ; pop parms
     342     282  0 +
     343     283  0 +                                             ;
     344     284  0 +                                             ;------------------------------------------+
     345     285  0 +                                             ;       Free heap storage [Jul 16, 2003]   |
     346     286  0 +                                             ;------------------------------------------+
     347     287  0 +  0000017F  A1 [00000000]:R                          mov  eax,dword ptr _Heap        ; Terminate the heap
     348     288  0 +  00000184  50                                       push eax
     349     289  0 +  00000185  B0 01                                    mov  al,1
     350     290  0 +  00000187  E8 00000000:E                            call DosSubUnsetMem
     351     291  0 +  0000018C  83 C4 04                                 add  esp,4
     352     292  0 +
     353     293  0 +  0000018F  A1 [00000000]:R                          mov  eax,dword ptr _Heap        ; Free heap storage
     354     294  0 +  00000194  50                                       push eax
     355     295  0 +  00000195  B0 01                                    mov  al,1
     356     296  0 +  00000197  E8 00000000:E                            call DosFreeMem
     357     297  0 +  0000019C  83 C4 04                                 add  esp,4
     358     298  0 +
     359     299  0 +  0000019F  8D 45 [D4]                               lea  eax,ERegRec[ebp]           ; Terminate Exception Handler
     360     300  0 +  000001A2  50                                       push eax
     361     301  0 +  000001A3  E8 00000000:E                            call DosUnsetExceptionHandler
     362     302  0 +  000001A8  83 C4 04                                 add  esp,4
     363     303  0 +  000001AB  A1 [00000234]:R                          mov  eax,dword ptr _pli_PGT+GBL*4 ; addr(globals)               20070524
     364     304  0 +  000001B0  8B 40 [04]                               mov  eax,gbl_return_code[eax]   ; Set task return code          20080521
     365     305  0 +  000001B3  50                                       push eax
     366     306  0 +  000001B4  6A 01                                    push 1                          ; Terminate all threads
     367     307  0 +  000001B6  E8 00000000:E                            call DosExit
     368     308  0 +                                                     page


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    8

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     369     309  0 +
     370     310  0 +                                             ;
     371     311  0 +                                             ;-----------------------------------------------------
     372     312  0 +                                             ;       _pli_sfi:  stack frame init at block entry
     373     313  0 +                                             ;       saves:     ebp,ebx,esi,edi
     374     314  0 +                                             ;       destroys:  ecx,edx
     375     315  0 +                                             ;       untouched: eax
     376     316  0 +                                             ;       does stack probes if size(local_stg)>4k
     377     317  0 +                                             ;-----------------------------------------------------
     378     318  0 +  000001BB  5F 70 6C 69 5F 53 46                     db   '_pli_SFI' ; Entry point name
                                 49
     379     319  0 +  000001C3  08                                       db   8          ; Length of name
     380     320  0 +  000001C4                                   _pli_sfi:
     381     321  0 +  000001C4  59                                       pop  ecx        ; restore return address
     382     322  0 +  000001C5  55                                       push ebp        ; [EBP+00]
     383     323  0 +  000001C6  8B EC                                    mov  ebp,esp    ; save stack ptr
     384     324  0 +  000001C8  8B 11                                    mov  edx,0[ecx] ; load size of locals
     385     325  0 +  000001CA  2B E2                                    sub  esp,edx    ; adjust ESP
     386     326  0 +  000001CC  C1 EA 0C                                 shr  edx,12     ; compute number of pages
     387     327  0 +  000001CF  83 FA 00                                 cmp  edx,0      ; < one page
     388     328  0 +  000001D2  74 19 90 90 90 90                        jz   endprobe   ; skip probe
     389     329  0 +  000001D8  8B D5                                    mov  edx,ebp    ; compute current page addr
     390     330  0 +  000001DA  C1 EA 0C                                 shr  edx,12
     391     331  0 +  000001DD  C1 E2 0C                                 shl  edx,12
     392     332  0 +                                             ;---    Stack Probe Loop ---
     393     333  0 +  000001E0                                   probe:
     394     334  0 +  000001E0  81 EA 00001000                           sub  edx,4096           ; back up one page
     395     335  0 +  000001E6  F6 02 00                                 test byte ptr 0[edx],0  ; test access
     396     336  0 +  000001E9  3B D4                                    cmp  edx,esp            ; All done
     397     337  0 +  000001EB  77 F3                                    ja   probe              ; loop for all pages 20060808
     398     338  0 +                                             ;---    End of Stack Probe Loop ---
     399     339  0 +  000001ED                                   endprobe:
     400     340  0 +                                             ;-------------------------------+
     401     341  0 +                                             ;       Format Stack frame      |
     402     342  0 +                                             ;-------------------------------+
     403     343  0 +  000001ED  89 65 [E0]                               mov  frm_bos[ebp],esp   ; Save BOS address
     404     344  0 +  000001F0  89 7D [FC]                               mov  frm_edi[ebp],edi   ; Save caller's registers
     405     345  0 +  000001F3  89 75 [F8]                               mov  frm_esi[ebp],esi   ;   (edi,esi,ebx)
     406     346  0 +  000001F6  89 5D [F4]                               mov  frm_ebx[ebp],ebx
     407     347  0 +  000001F9  8B D1                                    mov  edx,ecx            ; A(local size)
     408     348  0 +  000001FB  83 EA 02                                 sub  edx,2              ; A(entry point) 20020620
     409     349  0 +  000001FE  89 55 [F0]                               mov  frm_epa[ebp],edx
     410     350  0 +  00000201  C7 45 [EC] 00000000                      mov  dword ptr frm_stt[ebp],0   ; Statement number table
     411     351  0 +  00000208  C7 45 [E8] 00000000                      mov  dword ptr frm_chc[ebp],0   ; Initialize condition handler  0.6a
     412     352  0 +  0000020F  66:8B 15                                 mov  dx,word ptr _pli_Def_Cond  ; Enabled conditions            0.6a
                                 [000002CA]:R
     413     353  0 +  00000216  66:89 55 [E6]                            mov  frm_msk[ebp],dx            ; Condition mask                0.6a
     414     354  0 +  0000021A  C6 45 [E4] 00                            mov  byte ptr frm_epi[ebp],0    ; Entry point id                20050509
     415     355  0 +  0000021E  8B 75 [00]                               mov  esi,0[ebp]         ; Address of caller's stack frame       20020604
     416     356  0 +                                             ; NOTE: The caller's ESI should be zero only if this procedure is
     417     357  0 +                                             ;       called from another language (fromalien).  The condition
     418     358  0 +                                             ;       handler chain should still be set up by chasing the EBP
     419     359  0 +                                             ;       chain until a PL/I procedure is found.
     420     360  0 +  00000221  83 7D [F8] 00                            cmp  dword ptr frm_esi[ebp],0   ; Any backchain?                0.6a
     421     361  0 +  00000225  74 12 90 90 90 90                        je   sfi1               ; No, skip                              0.6a


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    9

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     422     362  0 +  0000022B  8B 56 [E8]                               mov  edx,frm_chc[esi]   ; Condition handler chain
     423     363  0 +  0000022E  89 55 [E8]                               mov  frm_chc[ebp],edx
     424     364  0 +  00000231  66:8B 56 [E6]                            mov  dx,frm_msk[esi]    ; Condition mask
     425     365  0 +  00000235  66:89 55 [E6]                            mov  frm_msk[ebp],dx
     426     366  0 +  00000239                                   sfi1:                           ;                                       0.6a
     427     367  0 +  00000239  FC                                       cld                     ; Clear direction flag
     428     368  0 +  0000023A  83 C1 04                                 add  ecx,4              ; skip over size
     429     369  0 +  0000023D  FF E1                                    jmp  ecx                ; return to caller
     430     370  0 +
     431     371  0 +                                             ;---------------------------------------+
     432     372  0 +                                             ; Address of exit routine               |
     433     373  0 +                                             ;---------------------------------------+
     434     374  0 +  0000023F  0000016A:R                       AExit   dd      exit
     435     375  0 +
     436     376  0 +  00000243  00000000                         Dummy   dd      0               ; Dummy resolution for _pli_Start in DLL   20080521
     437     377  0 +                                                     PAGE


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   10

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     438     378  0 +
     439     379  0 +                                                     .data
     440     380  0 +            =00000000                        _pli_data equ $
     441     381  0 +  00000000                                           align 4
     442     382  0 +                                             ;
     443     383  0 +                                             ;------------------------------------------------+
     444     384  0 +                                             ;       PL/I Program Global Table (PGT)          |
     445     385  0 +                                             ;       For upward-compatibility, do not move    |
     446     386  0 +                                             ;       or delete entries, or change the calling |
     447     387  0 +                                             ;       sequences.  New entries may be added.    |
     448     388  0 +                                             ;------------------------------------------------+
     449     389  0 +                                             ;             Memory comments, version, etc.
     450     390  0 +                                             ;             ....|....1....|....2....|....3
     451     391  0 +  00000000  50 4C 2F 49 20 30 2E                     db   'PL/I 0.1 Alpha  '         ; -56 -  -41
                                 31 20 41 6C 70 68 61
                                 20 20
     452     392  0 +  00000010  43 6F 70 79 72 69 67                     db   'Copyright Peter Flass,  ' ; -40 -  -17
                                 68 74 20 50 65 74 65
                                 72 20 46 6C 61 73 73
                                 2C 20 20
     453     393  0 +  00000028  53 65 70 2C 20 31 39                     db   'Sep, 1998       '         ; -16 -   -1
                                 39 38 20 20 20 20 20
                                 20 20
     454     394  0 +
     455     395  0 +                                             ;       Intrinsic Function IDs
     456     396  0 +            =00000000                        SFI     EQU  0          ; Stack Frame Init
     457     397  0 +            =00000004                        GSS     EQU  4          ; Get Stack storage                             20070320
     458     398  0 +            =00000006                        GHS     EQU  6          ; Get Heap storage
     459     399  0 +            =00000007                        FHS     EQU  7          ; Free Heap storage
     460     400  0 +            =00000010                        SIG     EQU  16         ; SIGNAL condition
     461     401  0 +            =00000011                        ONR     EQU  17         ; ON/REVERT condition
     462     402  0 +            =00000014                        OTH     EQU  20         ; Default OTHERWISE handler                     20050105
     463     403  0 +            =0000001E                        IOR     EQU  30         ; I/O Router
     464     404  0 +            =0000002E                        CCS     EQU  46         ; Compare character string
     465     405  0 +            =0000007F                        GBL     EQU  127        ; addr(_pli_gbl_data)                           20070524
     466     406  0 +            =00000080                        NIF     EQU  128        ; Number of entries in table
     467     407  0 +
     468     408  0 +                                                     extern _pli_IIC:near            ; Invalid call (compiler error)
     469     409  0 +                                                     extern _pli_GSS:near            ; (04) Get Stack Storage
     470     410  0 +                                                     extern _pli_GHS:near            ; (06) Get Heap Storage
     471     411  0 +                                                     extern _pli_FHS:near            ; (07) Free Heap Storage
     472     412  0 +                                                     extern _pli_Sig:near            ; (16) SIGNAL Condition
     473     413  0 +                                                     extern _pli_OnRev:near          ; (17) ON/REVERT Condition
     474     414  0 +                                                     extern _pli_OTH:near            ; (20) Default OTHERWISE handler20050105
     475     415  0 +                                                     extern _pli_IOR:near            ; (30) I/O Router
     476     416  0 +                                                     extern _pli_CCS:near            ; (46) Character String compare
     477     417  0 +
     478     418  0 +            =00000038                        _pli_PGT equ  $         ; PL/I intrinsic routine addresses
     479     419  0 +  00000038  000001C4:R                               dd   offset _pli_sfi            ; 0:    Stack Frame Init
     480     420  0 +  0000003C  00000000:E                               dd   offset _pli_IIC            ; 1:
     481     421  0 +  00000040  00000000:E                               dd   offset _pli_IIC            ; 2:
     482     422  0 +  00000044  00000000:E                               dd   offset _pli_IIC            ; 3:
     483     423  0 +  00000048  00000000:E                               dd   offset _pli_GSS            ; 4:    Get Stack Storage
     484     424  0 +  0000004C  00000000:E                               dd   offset _pli_IIC            ; 5:
     485     425  0 +  00000050  00000000:E                               dd   offset _pli_GHS            ; 6:    Get Heap Storage


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   11

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     486     426  0 +  00000054  00000000:E                               dd   offset _pli_FHS            ; 7:    Free Heap Storage
     487     427  0 +  00000058  00000000:E                               dd   offset _pli_IIC            ; 8:
     488     428  0 +  0000005C  00000000:E                               dd   offset _pli_IIC            ; 9:
     489     429  0 +  00000060  00000000:E                               dd   offset _pli_IIC            ; 10:
     490     430  0 +  00000064  00000000:E                               dd   offset _pli_IIC            ; 11:
     491     431  0 +  00000068  00000000:E                               dd   offset _pli_IIC            ; 12:
     492     432  0 +  0000006C  00000000:E                               dd   offset _pli_IIC            ; 13:
     493     433  0 +  00000070  00000000:E                               dd   offset _pli_IIC            ; 14:
     494     434  0 +  00000074  00000000:E                               dd   offset _pli_IIC            ; 15:
     495     435  0 +  00000078  00000000:E                               dd   offset _pli_Sig            ; 16:   SIGNAL condition
     496     436  0 +  0000007C  00000000:E                               dd   offset _pli_OnRev          ; 17:   ON/REVERT condition
     497     437  0 +  00000080  00000000:E                               dd   offset _pli_IIC            ; 18:
     498     438  0 +  00000084  00000000:E                               dd   offset _pli_IIC            ; 19:
     499     439  0 +  00000088  00000000:E                               dd   offset _pli_OTH            ; 20:   Default OTHERWISE handler 20050105
     500     440  0 +  0000008C  00000000:E                               dd   offset _pli_IIC            ; 21:
     501     441  0 +  00000090  00000000:E                               dd   offset _pli_IIC            ; 22:
     502     442  0 +  00000094  00000000:E                               dd   offset _pli_IIC            ; 23:
     503     443  0 +  00000098  00000000:E                               dd   offset _pli_IIC            ; 24
     504     444  0 +  0000009C  00000000:E                               dd   offset _pli_IIC            ; 25:
     505     445  0 +  000000A0  00000000:E                               dd   offset _pli_IIC            ; 26:
     506     446  0 +  000000A4  00000000:E                               dd   offset _pli_IIC            ; 27:
     507     447  0 +  000000A8  00000000:E                               dd   offset _pli_IIC            ; 28:
     508     448  0 +  000000AC  00000000:E                               dd   offset _pli_IIC            ; 29:
     509     449  0 +  000000B0  00000000:E                               dd   offset _pli_IOR            ; 30:   I/O Router
     510     450  0 +  000000B4  00000000:E                               dd   offset _pli_IIC            ; 31:
     511     451  0 +  000000B8  00000000:E                               dd   offset _pli_IIC            ; 32:
     512     452  0 +  000000BC  00000000:E                               dd   offset _pli_IIC            ; 33:
     513     453  0 +  000000C0  00000000:E                               dd   offset _pli_IIC            ; 34:
     514     454  0 +  000000C4  00000000:E                               dd   offset _pli_IIC            ; 35:
     515     455  0 +  000000C8  00000000:E                               dd   offset _pli_IIC            ; 36:
     516     456  0 +  000000CC  00000000:E                               dd   offset _pli_IIC            ; 37:
     517     457  0 +  000000D0  00000000:E                               dd   offset _pli_IIC            ; 38:
     518     458  0 +  000000D4  00000000:E                               dd   offset _pli_IIC            ; 39:
     519     459  0 +  000000D8  00000000:E                               dd   offset _pli_IIC            ; 40:
     520     460  0 +  000000DC  00000000:E                               dd   offset _pli_IIC            ; 41:
     521     461  0 +  000000E0  00000000:E                               dd   offset _pli_IIC            ; 42:
     522     462  0 +  000000E4  00000000:E                               dd   offset _pli_IIC            ; 43:
     523     463  0 +  000000E8  00000000:E                               dd   offset _pli_IIC            ; 44:
     524     464  0 +  000000EC  00000000:E                               dd   offset _pli_IIC            ; 45:
     525     465  0 +  000000F0  00000000:E                               dd   offset _pli_CCS            ; 46:   Compare character string
     526     466  0 +  000000F4  00000000:E                               dd   offset _pli_IIC            ; 47:
     527     467  0 +  000000F8  00000000:E                               dd   offset _pli_IIC            ; 48:
     528     468  0 +  000000FC  00000000:E                               dd   offset _pli_IIC            ; 49:
     529     469  0 +  00000100  00000000:E                               dd   offset _pli_IIC            ; 50:
     530     470  0 +  00000104  00000000:E                               dd   offset _pli_IIC            ; 51:
     531     471  0 +  00000108  00000000:E                               dd   offset _pli_IIC            ; 52:
     532     472  0 +  0000010C  00000000:E                               dd   offset _pli_IIC            ; 53:
     533     473  0 +  00000110  00000000:E                               dd   offset _pli_IIC            ; 54:
     534     474  0 +  00000114  00000000:E                               dd   offset _pli_IIC            ; 55:
     535     475  0 +  00000118  00000000:E                               dd   offset _pli_IIC            ; 56:
     536     476  0 +  0000011C  00000000:E                               dd   offset _pli_IIC            ; 57:
     537     477  0 +  00000120  00000000:E                               dd   offset _pli_IIC            ; 58:
     538     478  0 +  00000124  00000000:E                               dd   offset _pli_IIC            ; 59:
     539     479  0 +  00000128  00000000:E                               dd   offset _pli_IIC            ; 60:
     540     480  0 +  0000012C  00000000:E                               dd   offset _pli_IIC            ; 61:


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   12

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     541     481  0 +  00000130  00000000:E                               dd   offset _pli_IIC            ; 62:
     542     482  0 +  00000134  00000000:E                               dd   offset _pli_IIC            ; 63:
     543     483  0 +                                             ;------------------------------------------------ Only 0-63 currently defined
     544     484  0 +  00000138  00000000:E                               dd   offset _pli_IIC            ; 64:
     545     485  0 +  0000013C  00000000:E                               dd   offset _pli_IIC            ; 65:
     546     486  0 +  00000140  00000000:E                               dd   offset _pli_IIC            ; 66:
     547     487  0 +  00000144  00000000:E                               dd   offset _pli_IIC            ; 67:
     548     488  0 +  00000148  00000000:E                               dd   offset _pli_IIC            ; 68:
     549     489  0 +  0000014C  00000000:E                               dd   offset _pli_IIC            ; 69:
     550     490  0 +  00000150  00000000:E                               dd   offset _pli_IIC            ; 70:
     551     491  0 +  00000154  00000000:E                               dd   offset _pli_IIC            ; 71:
     552     492  0 +  00000158  00000000:E                               dd   offset _pli_IIC            ; 72:
     553     493  0 +  0000015C  00000000:E                               dd   offset _pli_IIC            ; 73:
     554     494  0 +  00000160  00000000:E                               dd   offset _pli_IIC            ; 74:
     555     495  0 +  00000164  00000000:E                               dd   offset _pli_IIC            ; 75:
     556     496  0 +  00000168  00000000:E                               dd   offset _pli_IIC            ; 76:
     557     497  0 +  0000016C  00000000:E                               dd   offset _pli_IIC            ; 77:
     558     498  0 +  00000170  00000000:E                               dd   offset _pli_IIC            ; 78:
     559     499  0 +  00000174  00000000:E                               dd   offset _pli_IIC            ; 79:
     560     500  0 +  00000178  00000000:E                               dd   offset _pli_IIC            ; 80:
     561     501  0 +  0000017C  00000000:E                               dd   offset _pli_IIC            ; 81:
     562     502  0 +  00000180  00000000:E                               dd   offset _pli_IIC            ; 82:
     563     503  0 +  00000184  00000000:E                               dd   offset _pli_IIC            ; 83:
     564     504  0 +  00000188  00000000:E                               dd   offset _pli_IIC            ; 84:
     565     505  0 +  0000018C  00000000:E                               dd   offset _pli_IIC            ; 85:
     566     506  0 +  00000190  00000000:E                               dd   offset _pli_IIC            ; 86:
     567     507  0 +  00000194  00000000:E                               dd   offset _pli_IIC            ; 87:
     568     508  0 +  00000198  00000000:E                               dd   offset _pli_IIC            ; 88:
     569     509  0 +  0000019C  00000000:E                               dd   offset _pli_IIC            ; 89:
     570     510  0 +  000001A0  00000000:E                               dd   offset _pli_IIC            ; 90:
     571     511  0 +  000001A4  00000000:E                               dd   offset _pli_IIC            ; 91:
     572     512  0 +  000001A8  00000000:E                               dd   offset _pli_IIC            ; 92:
     573     513  0 +  000001AC  00000000:E                               dd   offset _pli_IIC            ; 93:
     574     514  0 +  000001B0  00000000:E                               dd   offset _pli_IIC            ; 94:
     575     515  0 +  000001B4  00000000:E                               dd   offset _pli_IIC            ; 95:
     576     516  0 +  000001B8  00000000:E                               dd   offset _pli_IIC            ; 96:
     577     517  0 +  000001BC  00000000:E                               dd   offset _pli_IIC            ; 97:
     578     518  0 +  000001C0  00000000:E                               dd   offset _pli_IIC            ; 98:
     579     519  0 +  000001C4  00000000:E                               dd   offset _pli_IIC            ; 99:
     580     520  0 +  000001C8  00000000:E                               dd   offset _pli_IIC            ; 100:
     581     521  0 +  000001CC  00000000:E                               dd   offset _pli_IIC            ; 101:
     582     522  0 +  000001D0  00000000:E                               dd   offset _pli_IIC            ; 102:
     583     523  0 +  000001D4  00000000:E                               dd   offset _pli_IIC            ; 103:
     584     524  0 +  000001D8  00000000:E                               dd   offset _pli_IIC            ; 104:
     585     525  0 +  000001DC  00000000:E                               dd   offset _pli_IIC            ; 105:
     586     526  0 +  000001E0  00000000:E                               dd   offset _pli_IIC            ; 106:
     587     527  0 +  000001E4  00000000:E                               dd   offset _pli_IIC            ; 107:
     588     528  0 +  000001E8  00000000:E                               dd   offset _pli_IIC            ; 108:
     589     529  0 +  000001EC  00000000:E                               dd   offset _pli_IIC            ; 109:
     590     530  0 +  000001F0  00000000:E                               dd   offset _pli_IIC            ; 110:
     591     531  0 +  000001F4  00000000:E                               dd   offset _pli_IIC            ; 111:
     592     532  0 +  000001F8  00000000:E                               dd   offset _pli_IIC            ; 112:
     593     533  0 +  000001FC  00000000:E                               dd   offset _pli_IIC            ; 113:
     594     534  0 +  00000200  00000000:E                               dd   offset _pli_IIC            ; 114:
     595     535  0 +  00000204  00000000:E                               dd   offset _pli_IIC            ; 115:


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   13

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     596     536  0 +  00000208  00000000:E                               dd   offset _pli_IIC            ; 116:
     597     537  0 +  0000020C  00000000:E                               dd   offset _pli_IIC            ; 117:
     598     538  0 +  00000210  00000000:E                               dd   offset _pli_IIC            ; 118:
     599     539  0 +  00000214  00000000:E                               dd   offset _pli_IIC            ; 119:
     600     540  0 +  00000218  00000000:E                               dd   offset _pli_IIC            ; 120:
     601     541  0 +  0000021C  00000000:E                               dd   offset _pli_IIC            ; 121:
     602     542  0 +  00000220  00000000:E                               dd   offset _pli_IIC            ; 122:
     603     543  0 +  00000224  00000000:E                               dd   offset _pli_IIC            ; 123:
     604     544  0 +  00000228  00000000:E                               dd   offset _pli_IIC            ; 124:
     605     545  0 +  0000022C  00000000:E                               dd   offset _pli_IIC            ; 125:
     606     546  0 +  00000230  00000000:E                               dd   offset _pli_IIC            ; 126:
     607     547  0 +  00000234  00000000                                 dd   0                          ; 127:  _pli_gbl_data
     608     548  0 +            =00000238                        _pli_PGT_end equ $
     609     549  0 +
     610     550  0 +                                                     PAGE


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   14

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     611     551  0 +                                             ;
     612     552  0 +                                             ;------------------------------------------------+
     613     553  0 +                                             ;       Parameters for runtime library, etc.     |
     614     554  0 +                                             ;------------------------------------------------+
     615     555  0 +  00000238                                           align   4
     616     556  0 +  00000238                                   _pli_runtime_parms:
     617     557  0 +                                             ;def_heap_size  dd      65536                   ; Default Heap size - 64K
     618     558  0 +                                             ;def_heap_size  dd      1048576                 ; Default Heap size - 1MB
     619     559  0 +  00000238  00200000                         def_heap_size   dd      2097152                 ; Default Heap size - 2MB 20081216
     620     560  0 +  0000023C  00800000                         def_t1_stk_size dd      1048576*8               ; Stack size for thread 1 - 1MB
     621     561  0 +  00000240  00800000                         def_tn_stk_size dd      1048576*8               ; Stack size for thread n - 1MB
     622     562  0 +  00000244  00000000                         rtp_pCmdl       dd      0                       ; addr(parm)
     623     563  0 +  00000248  00000000                         rtp_lCmdl       dd      0                       ; length(parm)
     624     564  0 +  0000024C  006C * ( 00 )                                    db      108 DUP(0)              ; Reserved for add'l parms
     625     565  0 +
     626     566  0 +                                             ;------------------------------------------------+
     627     567  0 +                                             ;       Parameter for MAIN procedure             |
     628     568  0 +                                             ;       (NOTE: Can move to DSA)                  |
     629     569  0 +                                             ;------------------------------------------------+
     630     570  0 +  000002B8                                           align   4
     631     571  0 +  000002B8                                   _pli_Main_Parm_locdesc:                         ; Locator/Descriptor for Parm
     632     572  0 +  000002B8  000002B8:R                       adata   dd      $                               ;   Parm address
     633     573  0 +  000002BC  000002C0:R                       adesc   dd      offset desc                     ;   Descriptor address
     634     574  0 +  000002C0  11 00 00 00                      desc    db      11h,0,0,0                       ;   Varying String Descriptor
     635     575  0 +  000002C4  00000000                                 dd      0                               ;   . Max string length
     636     576  0 +
     637     577  0 +  000002C8                                           align   2
     638     578  0 +  000002C8  20 0F                            fpmask  db      20h,0Fh                         ; FPU Control word               20060214
     639     579  0 +                                             ;       LOB (exception masks):
     640     580  0 +                                             ;       ..1. .... PE Precision mask   '20'bx
     641     581  0 +                                             ;       ...1 .... UE Underflow mask   '10'bx
     642     582  0 +                                             ;       .... 1... OE Overflow mask    '08'bx
     643     583  0 +                                             ;       .... .1.. ZE Zerodivide mask  '04'bx
     644     584  0 +                                             ;       .... ..1. DE Denormal Op mask '02'bx
     645     585  0 +                                             ;       .... ...1 IE Invalid Op mask  '01'bx
     646     586  0 +                                             ;       HOB (control flags):
     647     587  0 +                                             ;       ...1 .... Infinity Control '01'bx
     648     588  0 +                                             ;       .... xx.. Rounding Control
     649     589  0 +                                             ;               '11'bx - Round toward zero (chop mode)
     650     590  0 +                                             ;       .... ..xx Precision Control
     651     591  0 +                                             ;               '11'bx - Double Extended Precision
     652     592  0 +                                             ;                                                 Double Extended Precision      20050624
     653     593  0 +                                             ;                                                 Round toward zero              20050624
     654     594  0 +                                             ;                                                 #P masked                      20050624
     655     595  0 +                                             ;------------------------------------------------+
     656     596  0 +                                             ;  Default enabled conditions                    |
     657     597  0 +                                             ;------------------------------------------------+
     658     598  0 +  000002CA                                   _pli_Def_Cond:
     659     599  0 +  000002CA  E1 80                                            db      0E1h,80h                ; Initial condition mask
     660     600  0 +                                             ;                       1... .... .... ....   Conversion
     661     601  0 +                                             ;                       .1.. .... .... ....   Fixedoverflow
     662     602  0 +                                             ;                       ..1. .... .... ....   Overflow
     663     603  0 +                                             ;                       ...0 .... .... .... NoSize
     664     604  0 +                                             ;                       .... 0... .... .... NoStringrange
     665     605  0 +                                             ;                       .... .0.. .... .... NoStringsize


    File: source\asm\init.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:   15

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     666     606  0 +                                             ;                       .... ..0. .... .... NoSubscriptrange
     667     607  0 +                                             ;                       .... ...1 .... ....   Underflow
     668     608  0 +                                             ;                       .... .... 1... ....   Zerodivide
     669     609  0 +                                             ;                       .... .... .... ...1 PL/I Library Function
     670     610  0 +                                             ;                       (remaining bits undefined, should be zero)
     671     611  0 +                                             ;                       (see PL/I compiler procedure 'KEYWORD')
     672     612  0 +
     673     613  0 +                                             ;------------------------------------------------+
     674     614  0 +                                             ;  External data shared between compiled code    +
     675     615  0 +                                             ;  and the PL/I library.  NOTE: This will not    +
     676     616  0 +                                             ;  work when the library is a DLL.  Find another +
     677     617  0 +                                             ;  scheme: Have the PGT contain or point to      +
     678     618  0 +                                             ;  a structure containing this data.             +
     679     619  0 +                                             ;------------------------------------------------+
     680     620  0 +                                             DGROUP  group  DATA32
     681     621  0 +
     682     622  0 +                                             _pli_End segment dword common '_pli_End'  ; Label variable for exit0020718
     683     623  0 +                                             ; Should be something like "_pli_Finish".
     684     624  0 +            =00000000                        _End    equ     $                       ;                         20020718
     685     625  0 +  00000000  00000000                                 dd      0                       ;                         20020718
     686     626  0 +  00000004  00000000                                 dd      0                       ;                         20020718
     687     627  0 +  00000008                                   _pli_End ends                           ;                         20020718
     688     628  0 +
     689     629  0 +                                             _pli_Heap segment dword common '_pli_Heap'; Address of heap storage 20030703
     690     630  0 +            =00000000                        _Heap   equ     $                       ;                         20030703
     691     631  0 +  00000000  00000000                                 dd      0                       ;                         20030703
     692     632  0 +  00000004                                   _pli_Heap       ends                    ;                         20030703
     693     633  0 +
     694     634  0 +                                                     end
