

    File: source\asm\math.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    1

    xxxx-ii-yyyy-cc-f--oooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


       1       1  0 +  0000                                   ;-------------------------------------------------------
       2       2  0 +                                         ;       Iron Spring PL/I Runtime Library Version 0.5
       3       3  0 +                                         ;          Distributed under the Gnu LGPL License
       4       4  0 +                                         ;
       5       5  0 +                                         ;       _pli_Math - PL/I runtime support routines
       6       6  0 +                                         ;       Version 0.8A Beta, 15 Dec, 2008
       7       7  0 +                                         ;       Copyright Peter Flass
       8       8  0 +                                         ;
       9       9  0 +                                         ;       This procedure is called to perform various math functions for
      10      10  0 +                                         ;       which the compiler does not generate the appropriate instructions.
      11      11  0 +                                         ;
      12      12  0 +                                         ;       Calling Sequence:
      13      13  0 +                                         ;         DCL MATH entry( fixed bin(31), float bin(64) )
      14      14  0 +                                         ;                  returns( float bin(64)
      15      15  0 +                                         ;                  ext( '_pli_Math')
      16      16  0 +                                         ;                  options(linkage(system));
      17      17  0 +                                         ;         The first argument is the function to be performed
      18      18  0 +                                         ;            (see jmptab).
      19      19  0 +                                         ;         The second argument is the function argument.
      20      20  0 +                                         ;
      21      21  0 +                                         ;       To Do:
      22      22  0 +                                         ;
      23      23  0 +                                         ;       Modifications:
      24      24  0 +                                         ;
      25      25  0 +                                         ;-------------------------------------------------------
      26      26  0 +            @Cpu=00000D9F                            .486P
      27      27  0 +                                                     .model flat,syscall
      28      28  0 +                                                     public _pli_Math
      29      29  0 +                                                     .data
      30      30  0 +            =00000000                        _pli_data equ $
      31      31  0 +                                                     include framedef.inc
      32  1    1  0 +                                             ;
      33  1    2  0 +                                             ;----------------------------------------------------+
      34  1    3  0 +                                             ;       PL/I Stack Frame Definition                  |
      35  1    4  0 +                                             ;----------------------------------------------------+
      36  1    5  0 +            =00000000                        frm_ebp equ      0      ; Previous caller's EBP 20040802
      37  1    6  0 +            =FFFFFFFC                        frm_edi equ     -4      ; Caller's EDI
      38  1    7  0 +            =FFFFFFF8                        frm_esi equ     -8      ; Caller's ESI
      39  1    8  0 +            =FFFFFFF4                        frm_ebx equ     -12     ; Caller's EBX
      40  1    9  0 +            =FFFFFFF0                        frm_epa equ     -16     ; Called Entry point address
      41  1   10  0 +            =FFFFFFEC                        frm_stt equ     -20     ; A(Statement number table)
      42  1   11  0 +            =FFFFFFE8                        frm_chc equ     -24     ; ONCB chain
      43  1   12  0 +            =FFFFFFE6                        frm_msk equ     -26     ; Condition mask
      44  1   13  0 +            =FFFFFFE4                        frm_epi equ     -28     ; Entry point id
      45  1   14  0 +            =FFFFFFE0                        frm_bos equ     -32     ; Current permanent BOS
      46  1   15  0 +            =00000020                        frm_len equ      32     ; Size of frame
      47  1   16  0 +
      48      32  0 +                                             ;------------------------------------------------+
      49      33  0 +                                             ;  Unique Stack Data for _pli_Math               |
      50      34  0 +                                             ;------------------------------------------------+
      51      35  0 +            =FFFFFFE0                        frm_loc equ     frm_bos         ; Start of locals for _pli_Math
      52      36  0 +            =FFFFFFDC                        loc_fpc equ     frm_loc-4       ; Saved fpucw
      53      37  0 +            =FFFFFFDC                        loc_end equ     frm_loc-4       ; end of local stack
      54      38  0 +            =00000004                        loc_len equ     frm_loc-loc_end ; Length of local stack
      55      39  0 +


    File: source\asm\math.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    2

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


      56      40  0 +                                                     .code                   ; PL/I Compatible entry code
      57      41  0 +            =00000000                        _pli_code equ $
      58      42  0 +  00000000  20 08 12 15 09 30 00                     byte 20h,08h,12h,15h,09h,30h,00h,00h
                                 00
      59      43  0 +                                             ;
      60      44  0 +                                             ;-----------------------------------------------------
      61      45  0 +                                             ;       _pli_Math:  PL/I Math Functions
      62      46  0 +                                             ;-----------------------------------------------------
      63      47  0 +  00000008  5F 70 6C 69 5F 4D 61                     byte   '_pli_Math'              ; Entry point name
                                 74 68
      64      48  0 +  00000011  09                                       byte   9                        ; Length of name
      65      49  0 +  00000012                                   _pli_Math:
      66      50  0 +  00000012  FF 17                                    call dword ptr 0[edi]           ; Init stack frame
      67      51  0 +  00000014  00000004                                 dd loc_len                      ; DSA size
      68      52  0 +  00000018  66:C7 45 [E4] 81E1                       mov word ptr -28[ebp],81E1h     ; Condition prefix flags
      69      53  0 +  0000001E  9B D9 7D [DC]                            fstcw loc_fpc[ebp]              ; Save fpcw
      70      54  0 +  00000022  D9 2D [00000000]:R                       fldcw fpmask                    ; Set new value
      71      55  0 +  00000028  DB 6D [0C]                               fld   tbyte ptr 12[ebp]         ; Load argument
      72      56  0 +  0000002B  8B 45 [08]                               mov   eax,8[ebp]                ; Load function code
      73      57  0 +                                             ;                                         (codes are arbitrary)
      74      58  0 +  0000002E  FF 24/85                                 jmp  jmptab[eax*4]              ; Go perform function
                                 [00000035]:R
      75      59  0 +            =00000035                        jmptab  equ  $
      76      60  0 +  00000035  000000D1:R                               dd   offset acos                ;  0=ACOS
      77      61  0 +  00000039  000000D1:R                               dd   offset asin                ;  1=ASIN
      78      62  0 +  0000003D  000000D1:R                               dd   offset atan                ;  2=ATAN
      79      63  0 +  00000041  000000D1:R                               dd   offset atand               ;  3=ATAND
      80      64  0 +  00000045  000000D1:R                               dd   offset atanh               ;  4=ATANH
      81      65  0 +  00000049  00000091:R                               dd   offset cos                 ;  5=COS
      82      66  0 +  0000004D  00000095:R                               dd   offset cosd                ;  6=COSD
      83      67  0 +  00000051  000000D1:R                               dd   offset cosh                ;  7=COSH
      84      68  0 +  00000055  000000D1:R                               dd   offset erf                 ;  8=ERF
      85      69  0 +  00000059  000000D1:R                               dd   offset erfc                ;  9=ERFC
      86      70  0 +  0000005D  000000D1:R                               dd   offset exp                 ; 10=EXP
      87      71  0 +  00000061  00000099:R                               dd   offset log                 ; 11=LOG
      88      72  0 +  00000065  000000A5:R                               dd   offset log2                ; 12=LOG2
      89      73  0 +  00000069  000000AD:R                               dd   offset log10               ; 13=LOG10
      90      74  0 +  0000006D  000000B9:R                               dd   offset sin                 ; 14=SIN
      91      75  0 +  00000071  000000BD:R                               dd   offset sind                ; 15=SIND
      92      76  0 +  00000075  000000D1:R                               dd   offset sinh                ; 16=SINH
      93      77  0 +  00000079  000000C1:R                               dd   offset sqrt                ; 17=SQRT
      94      78  0 +  0000007D  000000C5:R                               dd   offset tan                 ; 18=TAN
      95      79  0 +  00000081  000000CB:R                               dd   offset tand                ; 19=TAND
      96      80  0 +  00000085  000000D1:R                               dd   offset tanh                ; 20=TANH
      97      81  0 +  00000089  000000D1:R                               dd   offset gamma               ; 21=GAMMA
      98      82  0 +  0000008D  000000D1:R                               dd   offset loggamma            ; 22=LOGGAMMA
      99      83  0 +                                             ;
     100      84  0 +                                             ;-----------------------------------------------------
     101      85  0 +                                             ;       Functional Routines
     102      86  0 +                                             ;       Not implemented: acos, asin, atan, atand, atanh,
     103      87  0 +                                             ;         cosh (need e), erf, erfc, exp,
     104      88  0 +                                             ;         sinh (need e), tanh (need e), gamma, loggama.
     105      89  0 +                                             ;-----------------------------------------------------
     106      90  0 +  00000091  D9 FF                            cos:    fcos                            ; cos(x) in radians
     107      91  0 +  00000093  EB 46                                    jmp short  retrn


    File: source\asm\math.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    3

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     108      92  0 +  00000095  D9 FF                            cosd:   fcos                            ; cos(x) in radians
     109      93  0 +  00000097  EB 3A                                    jmp short  deg                  ; convert to degrees and exit
     110      94  0 +                                             ;       Compute loge(x).  This takes advantage of the identity:
     111      95  0 +                                             ;       logb(x) = logk(x)/logk(b), where b is the desired log base
     112      96  0 +                                             ;       and k is any arbitrary log base.  In this case loge(x)=log2(x)/log2(e)
     113      97  0 +  00000099  D9 E8                            log:    fld1                            ; Load 1.0 for fyl2x instruction
     114      98  0 +  0000009B  D9 C9                                    fxch                            ; ST(1)<-1.0, ST(0)<-x
     115      99  0 +  0000009D  D9 F1                                    fyl2x                           ; ST(0)<-log2(x)
     116     100  0 +  0000009F  D9 EA                                    fldl2e                          ; ST(0)<-log2(e), ST(1)<-log2(x)
     117     101  0 +  000000A1  DE F9                                    fdiv                            ; ST(0)<-loge(x)
     118     102  0 +  000000A3  EB 36                                    jmp short  retrn
     119     103  0 +  000000A5  D9 E8                            log2:   fld1                            ; Load 1.0
     120     104  0 +  000000A7  D9 C9                                    fxch                            ; ST(1)<-1.0, ST(0)<-x
     121     105  0 +  000000A9  D9 F1                                    fyl2x                           ; ST(0)<-log2(x)
     122     106  0 +  000000AB  EB 2E                                    jmp short  retrn
     123     107  0 +                                             ;       Compute log10(x), see note and comments for log function.
     124     108  0 +  000000AD  D9 E8                            log10:  fld1
     125     109  0 +  000000AF  D9 C9                                    fxch
     126     110  0 +  000000B1  D9 F1                                    fyl2x
     127     111  0 +  000000B3  D9 E9                                    fldl2t                          ; ST(0)<-log2(10), ST(1)<-log2(x)
     128     112  0 +  000000B5  DE F9                                    fdiv                            ; ST(0)<-log10(x)
     129     113  0 +  000000B7  EB 22                                    jmp short  retrn
     130     114  0 +  000000B9  D9 FE                            sin:    fsin                            ; sine(x) in radians
     131     115  0 +  000000BB  EB 1E                                    jmp short  retrn
     132     116  0 +  000000BD  D9 FE                            sind:   fsin                            ; sine(x) in radians
     133     117  0 +  000000BF  EB 12                                    jmp short  deg                  ; Convert to degrees and exit
     134     118  0 +  000000C1  D9 FA                            sqrt:   fsqrt                           ; ST(0)<-sqrt(x)
     135     119  0 +  000000C3  EB 16                                    jmp short  retrn
     136     120  0 +  000000C5  D9 F2                            tan:    fptan                           ; Partial tan(x) in ST(1), 1.0 in ST(0)
     137     121  0 +  000000C7  DD D8                                    fstp st(0)                      ; Pop the FPU stack
     138     122  0 +  000000C9  EB 10                                    jmp short  retrn
     139     123  0 +  000000CB  D9 F2                            tand:   fptan                           ; Partial tan(x) in ST(1), 1.0 in ST(0)
     140     124  0 +  000000CD  DD D8                                    fstp st(0)                      ; Pop the FPU stack
     141     125  0 +  000000CF  EB 02                                    jmp short  deg                  ; Convert to degrees and exit
     142     126  0 +                                             ;
     143     127  0 +                                             ;-----------------------------------------------------
     144     128  0 +                                             ;       Unimplemented Functions
     145     129  0 +                                             ;-----------------------------------------------------
     146     130  0 +  000000D1                                   acos:
     147     131  0 +  000000D1                                   asin:
     148     132  0 +  000000D1                                   atan:
     149     133  0 +  000000D1                                   atand:
     150     134  0 +  000000D1                                   atanh:
     151     135  0 +  000000D1                                   cosh:
     152     136  0 +  000000D1                                   erf:
     153     137  0 +  000000D1                                   erfc:
     154     138  0 +  000000D1                                   exp:
     155     139  0 +  000000D1                                   sinh:
     156     140  0 +  000000D1                                   tanh:
     157     141  0 +  000000D1                                   gamma:
     158     142  0 +  000000D1                                   loggamma:
     159     143  0 +  000000D1  EB 08                                    jmp short  retrn                ; (Just exit for now)
     160     144  0 +
     161     145  0 +                                             ;
     162     146  0 +                                             ;-----------------------------------------------------


    File: source\asm\math.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    4

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     163     147  0 +                                             ;       Return to caller
     164     148  0 +                                             ;-----------------------------------------------------
     165     149  0 +            =000000D3                        deg     equ  $                          ; Convert value in ST(0) to degrees
     166     150  0 +  000000D3  DB 2D [00000002]:R                       fld  tbyte ptr pi_180           ; ST(0)<-2pi/360
     167     151  0 +  000000D9  DE F9                                    fdiv                            ; Convert radians to degrees
     168     152  0 +                                             ;                                       ; Fall-thru to return
     169     153  0 +            =000000DB                        retrn   equ  $
     170     154  0 +  000000DB  D9 6D [DC]                               fldcw loc_fpc[ebp]              ; Restore fpcw
     171     155  0 +  000000DE  8B 5D [F4]                               mov ebx,dword ptr -12[ebp]
     172     156  0 +  000000E1  8B 75 [F8]                               mov esi,dword ptr -8[ebp]
     173     157  0 +  000000E4  8B 7D [FC]                               mov edi,dword ptr -4[ebp]
     174     158  0 +  000000E7  C9                                       leave
     175     159  0 +  000000E8  C3                                       ret
     176     160  0 +
     177     161  0 +                                                     .data
     178     162  0 +  00000000                                           align   2
     179     163  0 +  00000000  20 0B                            fpmask  db      20h,0Bh                         ; FPU Control word
     180     164  0 +                                             ;       LOB (exception masks):
     181     165  0 +                                             ;       ..1. .... PE Precision mask   '20'bx
     182     166  0 +                                             ;       ...1 .... UE Underflow mask   '10'bx
     183     167  0 +                                             ;       .... 1... OE Overflow mask    '08'bx
     184     168  0 +                                             ;       .... .1.. ZE Zerodivide mask  '04'bx
     185     169  0 +                                             ;       .... ..1. DE Denormal Op mask '02'bx
     186     170  0 +                                             ;       .... ...1 IE Invalid Op mask  '01'bx
     187     171  0 +                                             ;       HOB (control flags):
     188     172  0 +                                             ;       ...1 .... Infinity Control '01'bx
     189     173  0 +                                             ;       .... xx.. Rounding Control
     190     174  0 +                                             ;               '11'bx - Round toward zero (chop mode)
     191     175  0 +                                             ;       .... ..xx Precision Control
     192     176  0 +                                             ;               '11'bx - Double Extended Precision
     193     177  0 +                                             ;                                                 Double Extended Precision
     194     178  0 +                                             ;                                                 Round toward nearest
     195     179  0 +                                             ;                                                 #P masked
     196     180  0 +
     197     181  0 +                                             ;       Hexadecimal value of 2*PI/360 [=PI/180] (1.7453292520E-0002)
     198     182  0 +                                             ;       to convert radians to degrees
     199     183  0 +  00000002  AD C8 E9 94 12 35 FA             pi_180  byte    0ADh,0C8h,0E9h,094h,012h,035h,0FAh,08Eh,0F9h,03Fh
                                 8E F9 3F
     200     184  0 +
     201     185  0 +                                                     .code
     202     186  0 +            =000000E9                        _pli_endc equ $
     203     187  0 +                                                     .data
     204     188  0 +  00000000                                           org _pli_data+00h
     205     189  0 +            =00000000                        _pli_endd equ $
     206     190  0 +                                                     end
