

    File: source\asm\plistart.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    1

    xxxx-ii-yyyy-cc-f--oooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


       1       1  0 +  0000                                   ;-------------------------------------------------------
       2       2  0 +                                         ;       Iron Spring PL/I Runtime Library Version 0.5
       3       3  0 +                                         ;          Distributed under the Gnu LGPL License
       4       4  0 +                                         ;
       5       5  0 +                                         ;       _pli_Start - PL/I runtime support routines
       6       6  0 +                                         ;       Version 0.1 Alpha -- Dec, 2003
       7       7  0 +                                         ;       Copyright Peter Flass
       8       8  0 +                                         ;
       9       9  0 +                                         ;       PLISTART is statically linked with the user's .EXE.
      10      10  0 +                                         ;       It's function is to pass the address of the Global
      11      11  0 +                                         ;       Data Structure to _pli_Init, which performs the
      12      12  0 +                                         ;       actual initialization.
      13      13  0 +                                         ;
      14      14  0 +                                         ;       To Do:
      15      15  0 +                                         ;         . Get thread local storage for addr(TDA).
      16      16  0 +                                         ;         . Add country info.
      17      17  0 +                                         ;
      18      18  0 +                                         ;       Modifications:
      19      19  0 +                                         ;         2008-10-01 - Fix get and put entry variables in gbl      20081001
      20      20  0 +                                         ;                      so that get and put get condition chain     20081001
      21      21  0 +                                         ;         2008-05-21 - Fix startup logic for DLLs                  20080521
      22      22  0 +                                         ;         2004-06-09 - Add 'maj_task_TDA'
      23      23  0 +                                         ;
      24      24  0 +                                         ;-------------------------------------------------------
      25      25  0 +            @Cpu=00000D9F                            .486P
      26      26  0 +                                                     .model flat,syscall
      27      27  0 +                                                     public _pli_Start
      28      28  0 +                                             DGROUP  group  DATA32                   ;                          20080521
      29      29  0 +
      30      30  0 +                                                     .code
      31      31  0 +            =00000000                        _pli_code equ $
      32      32  0 +                                                     extern _pli_Init:near
      33      33  0 +                                                     extern _pli_Main:near
      34      34  0 +                                                     extern _pli_IIC:near
      35      35  0 +                                                     extern _pli_Tabs:near           ;                            @00003
      36      36  0 +                                             ;       WXTERNs for GET and PUT routines
      37      37  0 +                                                     extern _pli_Get(_pli_IIC):near
      38      38  0 +                                                     extern _pli_Put(_pli_IIC):near
      39      39  0 +                                             ;
      40      40  0 +                                             ;-----------------------------------------------------
      41      41  0 +                                             ;       _pli_Start:  Initialize PL/I MAIN procedure
      42      42  0 +                                             ;-----------------------------------------------------
      43      43  0 +  00000000  5F 70 6C 69 5F 53 74                     byte   '_pli_Start'             ; Entry point name
                                 61 72 74
      44      44  0 +  0000000A  0A                                       byte   10                       ; Length of name
      45      45  0 +  0000000B                                   _pli_Start:
      46      46  0 +  0000000B  8B EC                                    mov  ebp,esp                    ; Save DSA addr            20081001
      47      47  0 +  0000000D  8D 05 00000060:R                         lea  eax,maj_task_TDA           ; Load initial TDA address 20040609
      48      48  0 +  00000013  A3 [00000030]:R                          mov  gbl_TDA_anchor,eax         ; Store into GBL           20040609
      49      49  0 +  00000018  89 2D [00000014]:R                       mov  gbl_get_ep+4,ebp           ; Set backchain            20081001
      50      50  0 +  0000001E  89 2D [0000001C]:R                       mov  gbl_put_ep+4,ebp           ;  "     "                 20081001
      51      51  0 +  00000024  8D 05 00000000:R                         lea  eax,_pli_global_data
      52      52  0 +  0000002A  E9 00000000:E                            jmp  _pli_Init
      53      53  0 +
      54      54  0 +                                                     .data


    File: source\asm\plistart.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    2

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


      55      55  0 +            =00000000                        _pli_data equ $
      56      56  0 +                                             ;
      57      57  0 +                                             ;------------------------------------------------+
      58      58  0 +                                             ;       Global Data Area                         |
      59      59  0 +                                             ;------------------------------------------------+
      60      60  0 +  00000000                                           align   4
      61      61  0 +  00000000                                   _pli_global_data:
      62      62  0 +  00000000  00000060                         gbl_data_size   dword   gbl_data_len            ; Length of global data
      63      63  0 +  00000004  00000000                         gbl_return_code dword   0                       ; Return Code
      64      64  0 +  00000008  00000000:E                       gbl_main_ep     dword   _pli_Main               ; Address of MAIN       20080521
      65      65  0 +  0000000C  00000000                                         dword   0                       ; (second word of entry)20080521
      66      66  0 +  00000010  00000000:E                       gbl_get_ep      dword   _pli_Get                ; Address of GET routine
      67      67  0 +  00000014  00000000                                         dword   0                       ; (second word of entry)
      68      68  0 +  00000018  00000000:E                       gbl_put_ep      dword   _pli_Put                ; Address of PUT routine
      69      69  0 +  0000001C  00000000                                         dword   0                       ; (second word of entry)
      70      70  0 +  00000020  00000000                                         dword   0                       ; (reserved)
      71      71  0 +  00000024  00000000                                         dword   0                       ; "
      72      72  0 +  00000028  00000000                         gbl_User1       dword   0                       ; User field 1
      73      73  0 +  0000002C  00000000                         gbl_User2       dword   0                       ; User Field 2
      74      74  0 +  00000030  00000000                         gbl_TDA_anchor  dword   0                       ; addr(major_task_TDA)
      75      75  0 +  00000034  00000000                         gbl_alloc_cnt   dword   0                       ; Allocation count
      76      76  0 +  00000038  00000000:E                       gbl_plitabs_addr dword  _pli_Tabs               ; Address of PLITABS    20080522
      77      77  0 +                                             ;------- to add ----------------------------------------------------------------
      78      78  0 +                                             ;               Add country info?
      79      79  0 +                                             ;               Add addr(TDA_address) [TDA_address is stored in
      80      80  0 +                                             ;                 thread local storage.
      81      81  0 +                                             ;-------------------------------------------------------------------------------
      82      82  0 +  0000003C  0009 * ( 00000000 )                              dword   9 DUP(0)                ; (reserved, for now)
      83      83  0 +            =00000060                        gbl_data_len    equ     $-_pli_global_data      ; Area length
      84      84  0 +                                             ;               Expansion for _pli_global_data goes here
      85      85  0 +                                             ;
      86      86  0 +  00000060  0018 * ( 00000000 )              maj_task_TDA    dword  24 DUP(0)                ; Major task TDA (96 bytes) 20040609
      87      87  0 +
      88      88  0 +                                                     .stack  16384                           ; Minimal stack size for startup
      89      89  0 +
      90      90  0 +                                                     end _pli_Start
